diff options
author | Junio C Hamano <gitster@pobox.com> | 2008-05-12 15:44:43 -0700 |
---|---|---|
committer | Junio C Hamano <gitster@pobox.com> | 2008-05-12 15:44:43 -0700 |
commit | eafa29b7cb27fa0e14d9629e66d6866292620113 (patch) | |
tree | 2dfc167d2e661178dab11c4321481e5a9d432e72 /git-bisect.sh | |
parent | 65ea3b8c6d9517c5d7f2a6c089cc6578c9486114 (diff) | |
parent | 42ba5ee776c00369ca72b76537ae622611a7b545 (diff) | |
download | git-eafa29b7cb27fa0e14d9629e66d6866292620113.tar.gz |
Merge branch 'gp/bisect-fix'
* gp/bisect-fix:
bisect: print an error message when "git rev-list --bisect-vars" fails
git-bisect.sh: don't accidentally override existing branch "bisect"
Diffstat (limited to 'git-bisect.sh')
-rwxr-xr-x | git-bisect.sh | 38 |
1 files changed, 29 insertions, 9 deletions
diff --git a/git-bisect.sh b/git-bisect.sh index d8d9bfde4c..164e8ed81f 100755 --- a/git-bisect.sh +++ b/git-bisect.sh @@ -69,14 +69,19 @@ bisect_start() { head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) || head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) || die "Bad HEAD - I need a HEAD" + # + # Check that we either already have BISECT_START, or that the + # branches bisect, new-bisect don't exist, to not override them. + # + test -s "$GIT_DIR/BISECT_START" || + if git show-ref --verify -q refs/heads/bisect || + git show-ref --verify -q refs/heads/new-bisect; then + die 'The branches "bisect" and "new-bisect" must not exist.' + fi start_head='' case "$head" in refs/heads/bisect) - if [ -s "$GIT_DIR/BISECT_START" ]; then - branch=`cat "$GIT_DIR/BISECT_START"` - else - branch=master - fi + branch=`cat "$GIT_DIR/BISECT_START"` git checkout $branch || exit ;; refs/heads/*|$_x40) @@ -219,18 +224,33 @@ bisect_auto_next() { bisect_next_check && bisect_next || : } +eval_rev_list() { + _eval="$1" + + eval $_eval + res=$? + + if [ $res -ne 0 ]; then + echo >&2 "'git rev-list --bisect-vars' failed:" + echo >&2 "maybe you mistake good and bad revs?" + exit $res + fi + + return $res +} + filter_skipped() { _eval="$1" _skip="$2" if [ -z "$_skip" ]; then - eval $_eval + eval_rev_list "$_eval" return fi # Let's parse the output of: # "git rev-list --bisect-vars --bisect-all ..." - eval $_eval | while read hash line + eval_rev_list "$_eval" | while read hash line do case "$VARS,$FOUND,$TRIED,$hash" in # We display some vars. @@ -328,8 +348,8 @@ bisect_next() { exit_if_skipped_commits "$bisect_rev" echo "Bisecting: $bisect_nr revisions left to test after this" - git branch -f new-bisect "$bisect_rev" - git checkout -q new-bisect || exit + git branch -D new-bisect 2> /dev/null + git checkout -q -b new-bisect "$bisect_rev" || exit git branch -M new-bisect bisect git show-branch "$bisect_rev" } |